
;		        HD44780
;------------------------------------------------------------------------------------------------
; - 4-  ( )
; :	LcdPortDataOut (LcdDirData):

;	LcdOutData1	- DB4	- 
;	LcdOutData2	- DB5	- 
;	LcdOutData3	- DB6	- 
;	LcdOutData4	- DB7	- 

;		LcdPortSignOut (LcdDirSign):

;	LcdOutRS	- RS	- (1)/(0)
;	LcdOutE	- E	- 

;          
;2 ,     NOP    R/W  E,  
;   

;:
;	lcd_init	-  
;	lcd_com_write	-    
;	lcd_dat_write	-    
;	lcd_del	-  

;:	
;	Temp1	-   1
;	Temp2	-   2
;	Temp3	-   3
;	Temp4	-   4
;	LcdDataOut	-       

;   :

;	Presc0	-   0
;	Time0	-    0
;	LcdOutStep	-     
;	LcdRAM1	-    1 
;	LcdRAM1	-    2 
;	LcdRAM1	-    3 
;	LcdRAM1	-    4 

;:

;	_LcdSimb	-    

;;:

;	Sb_Int	-    

;:		 FlagsLCD:

;	 0	-  LCD_BUSY      
;	 1	-  LCD_TIM_ON      

;------------------------------------------------------------------------------------------------


;.def	LcdDataOut	=r1		;    /

;.equ	LcdPortDataOut	=PORTD
;.equ	LcdPortIn	=PIND
;.equ	E	=PD5
;.equ	RW	=PD6
;.equ	RS	=PD4
;.equ	LCD_OUT	=0b00000001		; LCD_OUT    
;.equ	LCD_BF	=0b00000100		; LCD_BF  

;------------------------------------------------------------------------------------------------

lcd_com_write:			;/    

	rcall	dis_int_sb
	cbi	LcdPortSignOut,LcdOutRS	;  RS ()
	rcall	lcd_out_byte		; 
	jmp	lcd_port_out_but	;  

lcd_dat_write:			;/    

	rcall	dis_int_sb
	sbi	LcdPortSignOut,LcdOutRS	;  RS ()
	rcall	lcd_out_byte		; 
	jmp	lcd_port_out_but	;  

lcd_out_byte:			;/    

	ldi	Temp1,2		; 
lcd_low1:	swap	LcdDataOut		; (Temp1=2)  (Temp1=1) ;  
	rcall	lcd_data_conv		; 
	sbi	LcdPortSignOut,LcdOutE	;  
	nop
	cbi	LcdPortSignOut,LcdOutE	;  E
	dec	Temp1		; 
	brne	lcd_low1		;  >< 0,   lcd_low1
	ret			;  /

dis_int_sb:			;/    

	chnc	GICR,(1<<Sb_Int)
	ret

en_int_sb:			;/    

	SKBC	FlagsButton, BUT_ON
	rjmp	en_int_sb2
	chns	GICR,(1<<Sb_Int)
en_int_sb2:	ret

lcd_data_conv:			;/    

	sbrs	LcdDataOut,0
	cbi	LcdPortDataOut,LcdOutData1	
	sbrc	LcdDataOut,0	
	sbi	LcdPortDataOut,LcdOutData1
	sbrs	LcdDataOut,1
	cbi	LcdPortDataOut,LcdOutData2
	sbrc	LcdDataOut,1
	sbi	LcdPortDataOut,LcdOutData2
	sbrs	LcdDataOut,2
	cbi	LcdPortDataOut,LcdOutData3
	sbrc	LcdDataOut,2
	sbi	LcdPortDataOut,LcdOutData3
	sbrs	LcdDataOut,3
	cbi	LcdPortDataOut,LcdOutData4
	sbrc	LcdDataOut,3
	sbi	LcdPortDataOut,LcdOutData4
	ret

lcd_port_out_but:		;/      

	cbi	LcdPortDataOut,LcdOutData1
	cbi	LcdPortDataOut,LcdOutData2
	cbi	LcdPortDataOut,LcdOutData3
	cbi	LcdPortDataOut,LcdOutData4
	cbi	LcdPortSignOut,LcdOutRS
	jmp	en_int_sb

lcd_init:			;/  

		; ~60 
	ldio	TCNT0,$16
	ldio	TCCR0,$5		;  /1024,  
	chns	TIMSK,(1<<TOIE0)	;    1
	SETB	FlagsLCD,LCD_TIM_ON	;  LCD_TIM_ON

li1:	SKBC	FlagsLCD,LCD_TIM_ON	;, LCD_TIM_ON 
	rjmp	li1
	ldi	LcdDataOut,$30	; 8-   (
	rcall	lcd_com_write

		; 4,1 
	ldio	TCNT0,$c0
	ldio	TCCR0,$4		;  /256,  
	chns	TIMSK,(1<<TOIE0)	;    1
	SETB	FlagsLCD,LCD_TIM_ON	;  LCD_TIM_ON

li2:	SKBC	FlagsLCD,LCD_TIM_ON	;, LCD_TIM_ON 
	rjmp	li2
	ldi	LcdDataOut,$30
	rcall	lcd_com_write

		; 100 
	ldio	TCNT0,$ce
	ldio	TCCR0,$2		;  /8,  
	chns	TIMSK,(1<<TOIE0)	;    1
	SETB	FlagsLCD,LCD_TIM_ON	;  LCD_TIM_ON

li3:	SKBC	FlagsLCD,LCD_TIM_ON	;, LCD_TIM_ON 
	rjmp	li3
	ldi	LcdDataOut,$28
	rcall	lcd_com_write

	rcall	lcd_del40
	ldi	LcdDataOut,$28	; 4-  ,2 ,5*7 
	rcall	lcd_com_write

	rcall	lcd_del40
	ldi	LcdDataOut,$d	; ,  -
	rcall	lcd_com_write

	rcall	lcd_del40
	ldi	LcdDataOut,$6	;   
	rcall	lcd_com_write

	rcall	lcd_del40
	rcall	lcd_clear
li8:	SKBC	FlagsLCD,LCD_TIM_ON	;, LCD_TIM_ON 
	rjmp	li8
	ret

lcd_init2:			;/  

	ldi	LcdDataOut,$28	; 8-   ()
	rcall	lcd_com_write

		; 4,1 
	ldio	TCNT0,$c0
	ldio	TCCR0,$4		;  /256,  
	chns	TIMSK,(1<<TOIE0)	;    1
	SETB	FlagsLCD,LCD_TIM_ON	;  LCD_TIM_ON

li2_5:	SKBC	FlagsLCD,LCD_TIM_ON	;, LCD_TIM_ON 
	rjmp	li2_5
	ldi	LcdDataOut,$d	; ,  -
	rcall	lcd_com_write

	rcall	lcd_del40
	ldi	LcdDataOut,$6	;   
	rcall	lcd_com_write

	rjmp	lcd_del40

lcd_del40:			;/     

		; 40 
	push	Temp1		; 2 

	ldi	Temp1,(COMM_PER_MCS*(40-11))/3; 1 
lcd40_1:	dec	Temp1		; 1 
	brne	lcd40_1		; 2   

	pop	Temp1		; 2 
	ret			; 4 

lcd_clear:			;/  

	ldi	LcdDataOut,$1	;      0 
	rcall	lcd_com_write
		; 1,8 
	ldio	TCNT0,$90
	ldio	TCCR0,$3		;  /64,  
	chns	TIMSK,(1<<TOIE0)	;    1
	SETB	FlagsLCD,LCD_TIM_ON;  LCD_TIM_ON
	ret

lcd_ram_out:		;/     

	SKBC	Flags,SOUND_ON
	ret
	ldi	LcdDataOut,$80	;   DDRAM -0
	rcall	lcd_com_write	;   
	rcall	lcd_del40		;  40

	ldi2	ZH,high(LcdRAM1),ZL,low(LcdRAM1)
	clr	Temp4
lro1:	ld	LcdDataOut,Z+	;  
	rcall	lcd_dat_write	;   
	rcall	lcd_del40		;  40
	inc	Temp4		; LcdOutStep
	cpi	Temp4,_LcdSimb/2
	brne	lro2		; LcdOutStep=_LcdSimb/2,  
	ldi	LcdDataOut,$c0	;   DDRAM -$40
	rcall	lcd_com_write	;   
	rcall	lcd_del40		;  40
	rjmp	lro1
lro2:	cpi	Temp4,_LcdSimb	; LcdOutStep=_LcdSimb,
	brne	lro1		;
	ret

.exit
