
;


;:

.def	Temp1		=r16	; 
.def	Temp2		=r17	; 
.def	Temp3		=r18	; 
.def	Temp4		=r19	; 
.def	Temp5		=r20	; 
.def	Temp6		=r21	; 
.def	LcdDataOut		=r22	;   
.def	Data1W		=r23	; 1wire

.def	SSREG		=r2	;  SREG
.def	Second		=r3	;  
.def	DataL		=r4	; 
.def	DataH		=r5	;  -  
.def	Mode		=r6	;  
.def	Cnt		=r7	;   
.def	Rate		=r8	;      
.def	DataML		=r10	; 
.def	DataMH		=r11	; 
.def	Tmp		=r9	; 
.def	Point		=r12	;    
.def	LcdOutStep		=r13	;     

;:

.equ	Flags		=TWBR	;  
.equ	FlagsLCD		=TWAR	;    
.equ	FlagsButton		=SPCR	;    
.equ	FlagsTermo		=UBRRL

.equ	LcdPortDataOut	=PORTC	;
.equ	LcdDirData		=DDRC
.equ	LcdPortSignOut	=PORTB
.equ	LcdDirSign		=DDRB
.equ	LcdOutData1		=PC2	;
.equ	LcdOutData2		=PC3	;
.equ	LcdOutData3		=PC4	;
.equ	LcdOutData4		=PC5	;
.equ	LcdOutRS		=PB1	;(1)/(0)
.equ	LcdOutE		=PB0	;
.equ	Sb_Int		=INT1
.equ	SbIn		=PD3	;   
.equ	BackLight		=PD6	;   
.equ	ZP		=PB4	; 
.equ	PowerInt		=PD2	;   
.equ	ButLight		=PD7	;   "Power"

;  :

.equ	TimerLoadFlag	=$60	;  
.equ	TimerLoadHourMem	=$61	;  
.equ	TimerLoadMinMem	=$62	;  
.equ	LcdRAM1		=$63	;   1 
.equ	LcdRAM2		=$73	;   2 

.equ	tASCII0		=$87	;   2-10 
.equ	tASCII1		=$86	;    
.equ	tASCII2		=$85	;   ,  
.equ	tASCII3		=$84
.equ	tASCII4		=$83
.equ	fASCIIL		=$87	;    2-10 
.equ	fASCIIH		=$88

.equ	Minute		=$89	;
.equ	Hour		=$8a	;
.equ	NameDays		=$8b	; 
.equ	Day		=$8c	; 
.equ	Month		=$8d	; 
.equ	Year		=$8e	;

.equ	AlrHr1		=$8f	;  1
.equ	AlrMin1		=$90	;  1
.equ	AlrND1		=$91	;   1
.equ	AlrContr11		=$92	;  1  1,   
.equ	AlrContr12		=$93	;  2  1,   

.equ	AlrHr2		=$94
.equ	AlrMin2		=$95
.equ	AlrND2		=$96
.equ	AlrContr21		=$97
.equ	AlrContr22		=$98

.equ	AlrHr3		=$99
.equ	AlrMin3		=$9a
.equ	AlrND3		=$9b
.equ	AlrContr31		=$9c
.equ	AlrContr32		=$9d

.equ	Adjust1H		=$a2	;  
.equ	Adjust1L		=$a3	;  

.equ	AdjustMem1H		=$a4	;   -  
.equ	AdjustMem1L		=$a5	;   -  

.equ	Adjust2H		=$a6	;  
.equ	Adjust2L		=$a7	;  

.equ	DataTerm1L		=$aa	;  
.equ	DataTerm1H		=$ab	;  

.equ	DataTerm2L		=$ac	;  
.equ	DataTerm2H		=$ad	;  

.equ	DataTerm3L		=$ae	;  
.equ	DataTerm3H		=$af	;  

.equ	DataVolt3L		=$b0	;     3 
.equ	DataVolt3H		=$b1	;     3 

.equ	DataFotoL		=$b2	;  
.equ	DataFotoH		=$b3	;  

.equ	DataFotoTrL		=$b4	;  
.equ	DataFotoTrH		=$b5

.equ	Data1Wire		=$b6	;   1-Wire 

.equ	DataContrast	=$b7	;  
.equ	CntBut		=$b8	; 
.equ	CntButDelay		=$b9	; 
.equ	CntButSet		=$ba	;  
.equ	CntBeep		=$bb	;  
.equ	CntHoldInd		=$bc	;  
.equ	CntLightOff		=$bd	;  

.equ	Count1W		=$be	;  1-Wire

.equ	LcdComWrite		=$bf	; ,   
.equ	NumbMelody		=$c0	;   
.equ	FlagsRAM		=$c1	;  
.equ	TimerLamp		=$c2	;  
.equ	TimerLampTemp	=$c3	;  - 
.equ	TimerLampPowH	=$c4	; 
.equ	TimerLampPowL	=$c5	; 

.equ	TimerLoadHour	=$c6	;  
.equ	TimerLoadMin	=$c7	;  

.equ	TempTerm0L		=$c8	; 
.equ	TempTerm0H		=$c9	;   
.equ	TempTermL		=$ca	; 
.equ	TempTermH		=$cb	; 

.equ	CntDataAver		=$cc	;  
.equ	MelodyBeginL	=$cd	; 
.equ	MelodyBeginH	=$ce	; 
.equ	NumbNoteMemL	=$cf	;  
.equ	NumbNoteMemH	=$d0	;  

.equ	SetTimHour		=$d1	;     
.equ	SetTimMin		=$d2	;     
.equ	SetTimDay		=$d3	;      
				;5 -/, 6 -, 7 -
.equ	SetTimPowL		=$d4	;    
.equ	SetTimPowH		=$d5	;    

.equ	SetTermostatL	=$d6	; 
.equ	SetTermostatH	=$d7	; 

.equ	DataMat1		=$e5	;   
.equ	DataMat2		=$e6	;   
.equ	DataMat3		=$e7	;   
.equ	DataMat4		=$e8	;   

.equ	DataMat5		=$e9	;   
.equ	DataMat6		=$ea	;   
.equ	DataMat7		=$eb	;   
.equ	DataMat8		=$ec	;   

.equ	CntRead1W		=$ed	;   

.equ	Data1WBuf_1		=$f0	;,   
	; :1   - 1   1- , 2   - 
	;1  2- , 4   - 2  1-   ... 27 

.equ	DataAverage		=$190	; 

;  EEPROM:

.equ	_TermK1L		=0	; . 
.equ	_TermK1H		=1	; . 
.equ	_TermK1OL		=2	; . 
.equ	_TermK1OH		=3	; . 

.equ	_TermB1L		=4	;   
.equ	_TermB1H		=5	;   
.equ	_TermB1L2		=6	;   
.equ	_TermB1H2		=7	;   

.equ	_TermK2L		=8
.equ	_TermK2H		=9
.equ	_TermK2OL		=10
.equ	_TermK2OH		=11

.equ	_TermB2L		=12
.equ	_TermB2H		=13
.equ	_TermB2L2		=14
.equ	_TermB2H2		=15

.equ	_TermK3L		=16
.equ	_TermK3H		=17
.equ	_TermK3OL		=18
.equ	_TermK3OH		=19

.equ	_TermB3L		=20
.equ	_TermB3H		=21
.equ	_TermB3L2		=22
.equ	_TermB3H2		=23

.equ	_TPoint0		=30	;    : ,, (    ),
.equ	_TPointEnd		=110	;  (L,H) -  5 
				;5 -/, 6 -, 7 -



;:

.equ	_LcdSimb		=16*2	;    (=*)
.equ	_ADCNumb		=5	;   +1
.equ	_TimBoun		=6	;  (*10 )
.equ	_TimIndHold		=3 * 4	;   (*0,25 )
.equ	_TimIndRet		=255	;    0 (*0,25 )
.equ	_TimSoundAlr	=240	;   (*0,25 )
.equ	_TimCntSet		=30	;     
.equ	_TimHoldBut		=100	;        
.equ	_TimSoundBut	=5	; ""    (*10 )
.equ	_TimSoundHour	=30	; ""   (*10 )
.equ	_AverNumb		=64	; 
.equ	_TimeDlitNote	=10	;   (*10 )
.equ	_Max		=$10	;
.equ	_Min		=$7fff	;
.equ	_Step		=(_Min-_Max)/(50/(_TimBoun/2))
.equ	_HistFoto		=500
.equ	_TimLampOff		=60	;     ,
.equ	_NumbDec		=1000	;     
.equ	_NumbMelShort	=6
.equ	cTimeRead1W		=200	;     

.equ	_fsck=4000000/64		;   c    0   


;:
	;FlagsLCD:
.equ	ONEW_ON		=0	;   1Wire
.equ	LCD_TIM_ON		=1	;      
.equ	LCD_COM		=2	;       
.equ	SUM_ON		=3	;      
.equ	SOUND_BUT		=4	;     
.equ	SOUND_HOUR		=5	;    
.equ	SOUND_SHORT		=6	;    
.equ	POWER_ON		=7	;  

	;FlagsButton:
	; 0-2 -   
.equ	BUT_ON		=3	;   
.equ	SUM_DEC		=4	;  
.equ	BUT_BOUN		=5	;   
.equ	MULTI		=6	;   
.equ	MULTI_CNT		=7	;     

	;Flags:
.equ	TIM_SECOND		=0	; "" 
.equ	BEEPING		=1	;   
.equ	ALARM_ON		=2	;  
.equ	POWER_OFF		=3	;  
.equ	LAMP_ON		=4	;   
.equ	LOAD_ON		=5	;   
.equ	NEGATIVE		=6	;  
.equ	SOUND_ON		=7	;    

	;     AlrContr:
.equ	ALR_ON		=0	;   
.equ	ALR_LAMP_ON		=1	;      
.equ	ALR_MUS_ON		=3	;      
.equ	ALR_SEARCH_ON	=2	;      

	;     FlagsRAM
.equ	TIMER_LAMP		=0	;    
;.equ	TIMER_POW_MEM	=1	;  
.equ	BUTLIGHT_ON		=2	; -  
.equ	BUTLIGHT_BL		=3	;   
.equ	SOUND_PAUSE		=4	;   
.equ	TEST_MELODY		=5	;  
.equ	BACKLIGHT_ON	=6	;   
.equ	BACKLIGHT_AUTO	=7	;    

	;      TimerLoadFlag
.equ	TIM_LOAD_ONOFF	=0	; - (   )
.equ	TIM_LOAD_CYCLE	=1	;   
.equ	TIM_ONE_EN		=2	;    
.equ	TSTAT_ONOFF		=3	; - 
.equ	TSTAT_EN		=4	;  
.equ	TPROG_EN		=5	;  

	;FlagsTermo:  6  7 
.equ	TERMO_DAT1		=0	;  
.equ	TERMO_DAT2		=1	;  
.equ	TERMO_DAT3		=2	;  

